1:0.9.8+bzr3319-0ubuntu1 regression: keeps setting gsettings keys to wrong values

Bug #1063617 reported by Martin Pitt on 2012-10-08
822
This bug affects 216 people
Affects Status Importance Assigned to Milestone
Compiz
High
Christopher Townsend
0.9.11
High
Christopher Townsend
compiz (Ubuntu)
High
Christopher Townsend
Trusty
Undecided
Unassigned

Bug Description

[Impact]

Many users set custom shortcuts in Compiz for various functionality. When this issue hits, many, if not all, of these custom shortcuts get reset to the defaults which can cause much frustration in the user. It is a very bad user experience.

[Test case]

1. Open CCSM
2. Set a custom shortcut or change a behavior. For example, go to General Options->Focus & Raise Behavior and uncheck Click To Focus.
3. Restart the Unity session multiple times.

[Regression potential]

None identified.

* Debdiff is found at https://launchpadlibrarian.net/178439518/compiz-trusty-sru-2.debdiff *

Original Description:

NOTE: This bug is for Ubuntu 12.10 and later only. If you experience something similar in 12.04 then please see bug 964270.

ORIGINAL DESCRIPTION:
Since version 1:0.9.8+bzr3319-0ubuntu1, compiz/unity keeps messing up my gsettings (keybindings and WM prefs). This was already covered in bug 1042041, but the change there mostly caused the bug to happen consistently now.

At every session startup I have a script to fix my settings like this:

--------------- 8< ----------------
gsettings reset org.gnome.desktop.wm.preferences auto-raise
gsettings set org.gnome.desktop.wm.keybindings lower "['<Alt>b']"
gsettings set org.gnome.desktop.wm.keybindings maximize "['<Super>Up']"
gsettings set org.gnome.desktop.wm.keybindings unmaximize "['<Super>Down']"
gsettings set org.gnome.desktop.wm.preferences focus-mode sloppy
--------------- 8< ----------------

But after restarting compiz, it changes the settings to:

--------------- 8< ----------------
$ gsettings get org.gnome.desktop.wm.preferences auto-raise
true
$ gsettings get org.gnome.desktop.wm.keybindings lower
['disabled']
$ gsettings get org.gnome.desktop.wm.keybindings maximize
['<Control><Primary><Super>Up']
$ gsettings get org.gnome.desktop.wm.keybindings unmaximize
['<Control><Primary><Super>Down']
$ gsettings get org.gnome.desktop.wm.preferences focus-mode
'click'
--------------- 8< ----------------

I tried to move away /usr/bin/session-migration, that does not change anything, so it's not that script.

ProblemType: Bug
DistroRelease: Ubuntu 12.10
Package: compiz 1:0.9.8.4-0ubuntu1
ProcVersionSignature: Ubuntu 3.5.0-17.27-generic 3.5.5
Uname: Linux 3.5.0-17-generic x86_64
.tmp.unity.support.test.0:

ApportVersion: 2.6.1-0ubuntu1
Architecture: amd64
CompizPlugins: [core,composite,opengl,compiztoolbox,decor,vpswitch,snap,mousepoll,resize,place,move,wall,grid,regex,imgpng,session,gnomecompat,animation,fade,unitymtgrabhandles,workarounds,scale,expo,ezoom,unityshell]
CompositorRunning: compiz
Date: Mon Oct 8 10:23:04 2012
DistUpgraded: Fresh install
DistroCodename: quantal
DistroVariant: ubuntu
EcryptfsInUse: Yes
GraphicsCard:
 Intel Corporation Core Processor Integrated Graphics Controller [8086:0046] (rev 02) (prog-if 00 [VGA controller])
   Subsystem: Lenovo Device [17aa:215a]
InstallationMedia: Ubuntu 12.10 "Quantal Quetzal" - Alpha amd64 (20120627)
MachineType: LENOVO 3323REG
PackageArchitecture: all
PlymouthDebug: Error: [Errno 13] Keine Berechtigung: '/var/log/plymouth-debug.log'
ProcEnviron:
 TERM=xterm
 PATH=(custom, no user)
 XDG_RUNTIME_DIR=<set>
 LANG=de_DE.UTF-8
 SHELL=/bin/bash
ProcKernelCmdLine: BOOT_IMAGE=/boot/vmlinuz-3.5.0-17-generic root=UUID=8f327c01-56d7-401c-8bd1-5442854e3c85 ro quiet splash vt.handoff=7
SourcePackage: compiz
UpgradeStatus: No upgrade log present (probably fresh install)
dmi.bios.date: 06/07/2010
dmi.bios.vendor: LENOVO
dmi.bios.version: 6QET46WW (1.16 )
dmi.board.name: 3323REG
dmi.board.vendor: LENOVO
dmi.board.version: Not Available
dmi.chassis.asset.tag: No Asset Information
dmi.chassis.type: 10
dmi.chassis.vendor: LENOVO
dmi.chassis.version: Not Available
dmi.modalias: dmi:bvnLENOVO:bvr6QET46WW(1.16):bd06/07/2010:svnLENOVO:pn3323REG:pvrThinkPadX201:rvnLENOVO:rn3323REG:rvrNotAvailable:cvnLENOVO:ct10:cvrNotAvailable:
dmi.product.name: 3323REG
dmi.product.version: ThinkPad X201
dmi.sys.vendor: LENOVO
version.compiz: compiz 1:0.9.8.4-0ubuntu1
version.ia32-libs: ia32-libs N/A
version.libdrm2: libdrm2 2.4.39-0ubuntu1
version.libgl1-mesa-dri: libgl1-mesa-dri 9.0~git20121004.b2048c5e-0ubuntu1
version.libgl1-mesa-dri-experimental: libgl1-mesa-dri-experimental N/A
version.libgl1-mesa-glx: libgl1-mesa-glx 9.0~git20121004.b2048c5e-0ubuntu1
version.xserver-xorg-core: xserver-xorg-core 2:1.13.0-0ubuntu5
version.xserver-xorg-input-evdev: xserver-xorg-input-evdev 1:2.7.3-0ubuntu1
version.xserver-xorg-video-ati: xserver-xorg-video-ati 1:6.99.99~git20120913.8637f772-0ubuntu1
version.xserver-xorg-video-intel: xserver-xorg-video-intel 2:2.20.9-0ubuntu2
version.xserver-xorg-video-nouveau: xserver-xorg-video-nouveau 1:1.0.2-0ubuntu3

Related branches

lp:~compiz-team/compiz/compiz.fix_1063617.1
Merged into lp:compiz/0.9.9 at revision 3484
Daniel van Vugt: Approve on 2012-11-26
PS Jenkins bot: Approve (continuous-integration) on 2012-11-25
lp:~compiz-team/compiz/compiz.fix_1063617.2
Daniel van Vugt: Approve on 2012-11-28
PS Jenkins bot: Approve (continuous-integration) on 2012-11-27
lp:~compiz-team/compiz/compiz.fix_1063617.3
Merged into lp:compiz/0.9.9 at revision 3486
PS Jenkins bot: Needs Fixing (continuous-integration) on 2012-11-26
Daniel van Vugt: Approve on 2012-11-26
lp:~compiz-team/compiz/compiz.fix_1063617.4
Daniel van Vugt: Approve on 2012-11-27
PS Jenkins bot: Approve (continuous-integration) on 2012-11-26
lp:~compiz-team/compiz/compiz.fix_1063617.5
Daniel van Vugt: Approve on 2012-11-26
PS Jenkins bot: Approve (continuous-integration) on 2012-11-25
lp:~compiz-team/compiz/compiz.fix_1063617.6
Merged into lp:compiz/0.9.9 at revision 3491
Sam Spilsbury: Approve on 2012-11-29
PS Jenkins bot: Approve (continuous-integration) on 2012-11-29
Daniel van Vugt: Approve on 2012-11-29
lp:~compiz-team/compiz/compiz.fix_1063617.8
Merged into lp:compiz/0.9.9 at revision 3518
Daniel van Vugt: Approve on 2012-12-10
PS Jenkins bot: Approve (continuous-integration) on 2012-12-07
Sam Spilsbury: Pending requested 2012-12-07
lp:~compiz-team/compiz/compiz.fix_1063617.7
Merged into lp:compiz/0.9.9 at revision 3506
PS Jenkins bot: Needs Fixing (continuous-integration) on 2012-12-05
Sam Spilsbury: Approve on 2012-12-05
Daniel van Vugt: Approve on 2012-12-05
lp:~compiz-team/compiz/compiz.fix_1063617.9.1
Merged into lp:compiz/0.9.9 at revision 3610
Marco Trevisan (Treviño): Approve on 2013-02-18
PS Jenkins bot: Approve (continuous-integration) on 2013-02-13
lp:~vanvugt/compiz/fix-1089251
Merged into lp:compiz/0.9.9 at revision 3527
Sam Spilsbury: Approve on 2012-12-12
PS Jenkins bot: Approve (continuous-integration) on 2012-12-12
lp:~townsend/compiz/fix-lp1063617
Merged into lp:compiz/0.9.11 at revision 3867
Brandon Schaefer: Approve on 2014-05-21
PS Jenkins bot: Approve (continuous-integration) on 2014-05-21
lp:~townsend/compiz/0.9.11.1
Merged into lp:compiz/0.9.11 at revision 3861
Stephen M. Webb: Approve on 2014-06-12
PS Jenkins bot: Approve (continuous-integration) on 2014-06-11
Martin Pitt (pitti) wrote :
Martin Pitt (pitti) wrote :

I disabled all *.convert files in /usr/share/GConf/gsettings and restarted again. This caused "org.gnome.desktop.wm.preferences auto-raise" to now remain on false, so it seems this key is affected by the gconf migration. This is handled by wm-schemas.convert:

auto-raise = /apps/metacity/general/auto_raise

However, the gconf value is correct:

$ gconftool -g /apps/metacity/general/auto_raise
false

All other keys have the same wrong default value still, so for the keybindings and focus values it's compiz itself which apparently resets the values to their schema defaults on every startup?

Martin Pitt (pitti) wrote :

I tried this with a freshly created user account. After the first startup ever, the settings are like this:

test@donald:~$ gsettings get org.gnome.desktop.wm.preferences auto-raise
false
test@donald:~$ gsettings get org.gnome.desktop.wm.keybindings lower
@as []
test@donald:~$ gsettings get org.gnome.desktop.wm.keybindings maximize
['<Super>Up', '<Primary><Super>Up', '<Primary><Alt>KP_5']
test@donald:~$ gsettings get org.gnome.desktop.wm.keybindings unmaximize
['<Super>Down', '<Alt>F5', '<Primary><Super>Down']
test@donald:~$ gsettings get org.gnome.desktop.wm.preferences focus-mode
'click'

I. e. auto-raise is correct, the "lower" keybindings is an empty array instead of ['disabled'], and the other keys are as expected. Now I run the "gsettings set ..." stuff as in the description. After restarting the session, compiz does the same thing as for me: it changes the gsettings to the values that I showed in the description, except that it keeps auto-raise to false.

However, what's really curious is that my originally configured keybindings, such as Super-Down, as well as sloppy focus still actually work, even though the current gsettings say otherwise! This is only the case for the fresh user account, not for my real account (where the gsettings match the actual behaviour).

Martin Pitt (pitti) wrote :

If I restart the "test" user session again, the focus and keybinding gsettings keys are unchanged since the second session, but now the behaviour matches the gsettings again, i. e. the '<Control><Primary><Super>Up' keybindings, disabled "lower" binding, and click-to-focus. I also now have "auto-raise" set to true.

This sounds like compiz would first read gsettings, then configure itself according to them, and only afterwards change the gsettings to these values?

Also, it demonstrates that this bug is 100% reproducible with a fresh user account, and not special to mine.

Changed in compiz (Ubuntu):
status: New → Confirmed

I'm having a similiar problem where I uncheck the Click to Focus setting in ccsm, but it it will be checked again on next login. Probably for the same reason as described here.

Changed in compiz:
status: New → Confirmed
Daniel van Vugt (vanvugt) wrote :

I feel reports of this problem got worse in 12.10, but it was pre-existing in bug 986208. Is this a duplicate?

Changed in compiz:
milestone: none → 0.9.9.0
everflux (tklaunchpad) wrote :

Using the gnome classic/fallback session I have the very same problem on two different machines.

Martin Pitt (pitti) wrote :

Possible duplicates: bug 964270, bug 1074453

Tom Jaeger (thjaeger) wrote :

Isn't this one itself a dup of bug 986208? In any case, here's a stack trace.

Changed in compiz:
assignee: nobody → Sam Spilsbury (smspillaz)
importance: Undecided → Medium
Changed in compiz:
status: Confirmed → In Progress
Changed in compiz (Ubuntu):
status: Confirmed → In Progress
description: updated
Changed in compiz (Ubuntu):
assignee: nobody → Sam Spilsbury (smspillaz)
importance: Undecided → Medium
Changed in compiz:
status: In Progress → Fix Committed
Daniel van Vugt (vanvugt) wrote :

In progress till all parts of the fix have landed.

Changed in compiz:
status: Fix Committed → In Progress
Mathieu Delarue (mathipu) wrote :

I'm having the same problem with Viewport Switcher keybindings <Alt>1-9

This is happeniing in the same way on my laptop and my desktop.

I moved over from this bug:
https://bugs.launchpad.net/ubuntu/+source/gnome-control-center/+bug/964270

TomasHnyk (sup) wrote :

Is the fix for this going to be pushed into Quantal?

Daniel van Vugt (vanvugt) wrote :

Sam has suggested the final fix may be too big and complex to backport. But I will certainly try to get it in quantal. This bug is a big deal.

Changed in compiz:
importance: Medium → High
Changed in compiz (Ubuntu):
importance: Medium → High
Changed in compiz:
status: In Progress → Fix Committed
Changed in compiz:
status: Fix Committed → In Progress
Changed in compiz:
status: In Progress → Fix Committed
Daniel van Vugt (vanvugt) wrote :

It's not Fix Committed till all of Sam's branches have landed.

This is why we should ideally only ever have one branch per fix. Unless you're separating a simple fix from more complex refactoring for better testing.

Changed in compiz:
status: Fix Committed → In Progress
Changed in compiz:
status: In Progress → Fix Committed
Changed in compiz:
status: Fix Committed → In Progress
Changed in compiz:
status: In Progress → Fix Committed
Changed in compiz:
status: Fix Committed → In Progress
Sam Spilsbury (smspillaz) wrote :

Would it be better to unlink the "progress" branches from the actual fix then?

Seems like we're fighting the merge bot here for no reason.

Mathieu Delarue (mathipu) wrote :

Oh, boo. Someone broke "daily" over the last couple of days for me. Whatever. I backed out of daily and I'm back to Quantal after a little wrangling with apt and dpkg. I'm sure there's any easier way to back out but that would mean I'd have to go read something somewhere.

So anyway, I think this bug was fixed in daily in that it hasn't bothered me in a while.

I wish I could get it in Quantal! :-)

Daniel van Vugt (vanvugt) wrote :

smspillaz: It's a trivial issue that only occupies a couple of seconds every couple of days. I think we're better off keeping the clarity and the accurate paper trail of all the links.

Daniel van Vugt (vanvugt) wrote :

Linked the fix for bug 1089251 too. That's a crash caused by one of the fixes for this bug.

Floby (florent-jaby) wrote :

I've got this bug on every restart in Quantal. System Settings > Keyboard > Shortcuts keeps showing the custom values but they are not effective.

Changed in compiz:
status: In Progress → Fix Committed
Changed in compiz:
status: Fix Committed → In Progress
1 comments hidden view all 113 comments
Jerry Quinn (jlquinn) wrote :

I just got bit by this issue in 12.10 for the first time.

I had focus-follows-mouse set, Alt-down-arrow set to lower window, and Alt-up-arrow to raise window. All 3 got reset on me somehow.

vlk (vkazanov) wrote :

It seems that I have this bug too. Is it going to be fixed any time soon?

Am also affected by this. An imminent fix would be most welcome!

This seems to be a workaround: open compizconfig-settings-manager > Preferences > Backend and set it to "Flat-file configuration Backend".

Krister (thekswenson) wrote :

WARNING!!!!
Only do Andre's (desgua) workaround if you want Unity to get completely screwed.
Changing that setting rendered my session frozen and subsequent logins yielded only a desktop!

My unsatisfying path back to a usable system:

The default hotkeys to open a terminal worked so that I could open ccsm and switch out of flatfile mode.
This didn't fix the problem (no window decoration, HUD or bar at the left and top). I then re-enabled the Unity plugin.
Now I'm in the process of trying to reconfigure everything.
The settings in Unity are now "out of sync" with those of ccsm and changing, for example, "Launcher Icon Size" in the appearance window does nothing...
   anyone know how to restore things to normal?

@Krister I am sorry for the consequences you have experienced, here it
works fine. I suspect that there is another configuration messed on your
compiz settings. You can reset to defaults going to Preferences and hitting
Reset to Defaults.
Regards.

JD Rogers (rogersjd) wrote :

I can confirm Krister's experience, the Flat-file configuration and unity don't play well together and I lost my launcher and all functionality. I moved all my config files from a terminal and started with a completely fresh clean default including:
.compiz/
.compiz-1/
.config/
.gconf/
.gnome2/
.local/

and after login, I set a couple of keybindings in unity settings, then launched ccsm which changed those bindings on its first run, then I selected flat-file config in the prefs and my launcher dissapeared and I can't yet get it back. Apparently, "unity --reset" is deprecated, so I may have to wipe my new default config files again.

JD Rogers (rogersjd) wrote :

Well, this is nifty.. I wasn't too concerned about trying Andre's workaround even with Krister's comment since I first backed up my setting in ccsm. After moving the above dot files back into play, I loaded ccsm and imported my exported settings and now none of unity's settings are having any effect. Like Krister, launcher icon size is no longer controlled by the system setting through unity.

@Krister, I got the icon size back using ccsm under unityplugin->experimental->icon size, but I have no idea why these things can no longer be set using the system settings.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package compiz - 1:0.9.9~daily13.01.14-0ubuntu1

---------------
compiz (1:0.9.9~daily13.01.14-0ubuntu1) raring; urgency=low

  [ sampo555 ]
  * compiz crashed with SIGSEGV in DodgeAnim::applyDodgeTransform() (LP:
    #1048840)
  * compiz crashing if window un-/minimize animation is "Random" (LP:
    #1098185)

  [ Daniel van Vugt ]
  * Several leaks in new GLProgram from compileProgram() from
    GLScreen::getProgram() from GLWindowAutoProgram::getProgram() (LP:
    #1097644)

  [ Sam Spilsbury ]
  * Several leaks in ccsIntegratedSettingListAppend() ... from
    ccsGNOMEIntegrationBackendGetIntegratedSetting() from readSetting
    (gsettings.c:375) (LP: #1097661)

  [ MC Return ]
  * Thumbnail Window Previews: Flickering of background/glow and window
    title text (LP: #1098758)

  [ Automatic PS uploader ]
  * Automatic snapshot from revision 3561
 -- Automatic PS uploader <email address hidden> Mon, 14 Jan 2013 04:03:09 +0000

Changed in compiz (Ubuntu):
status: In Progress → Fix Released
sash_ (sascha7312x98) wrote :

I am also affected by this bug. Is there any chance to get the updated packages from 13.04 into 12.10?

Wolfgang Schnerring (wosc) wrote :

Another vote for backporting the fix to 12.10, pretty please -- compiz / gnome-classic is quite unusable if it randomly changes your settings underneath you. Is there anything I can do to help?

Changed in compiz:
milestone: 0.9.9.0 → 0.9.9.2
Ivo Anjo (knuckles) wrote :

+1 Asking for backport to 12.10. This renders the keyboard shortcuts dialog useless.

DavidHuttlestonJr (dhjr) wrote :

Please backport to 12.10. The default unity keyboard setting mess with my emacs keys. And, ccsm is the only way to get a 3x3 grid of workspaces.

Changed in compiz:
status: In Progress → Fix Committed
sportiel (a-sportiello) wrote :

Hi all. I have the same problem (ubuntu 12.10, compiz 0.9.8.6). Now, the weird thing is that the behaviour is unpredictable for me. I use mainly 5 shortcuts: Ctrl-Shift-T for new tab, and Ctrl-F1 ... F4 for switching workspaces. What I observed... (1) the Ctrl-Shift-T is never washed out; (2) the Ctrl-F(x)'s are washed out at boot, bot __only sometimes__, not at all boots! (I'm on a laptop, thus I reboot often). Thus, differently from other people in the thread, I do not know how to make this reproducible (and this sounds strange to me...)

Adam Colligan (adam-p) wrote :

I'm having what I think is this bug in 13.04 Raring, with Compiz 1:0.9.9~daily13.03.08-0ubuntu1 (from yesterday). Has this fix been merged into the dailies yet?

I am also begging for a backport to 12.10 !!!
Since upgrading to Quantal, this very annoying behavior of not remembering shortcuts across logout/logins has forced me to revert to using 12.04LTS...I have been using two shortcuts for a very long time: one for closing a window and one for minimizing. I got so much used to them that being unable to continue using them with 12.10 is an absolute no-go for me! And I am not at all willing to have to reset those shortcuts at the beginning of each session.
In my own personal opinion, this bug make 12.10 unsuitable and unusable for me.
And I don't understand why a backport would be so difficult to release - while a fix is now available - is it so difficult to backport this to 12.10?
If backporting would unfortunately be impossible, does anybody know of a way to force the settings I want by using a script?

Øyvind Stegard (oyvinst) wrote :

Gilles Tournier <email address hidden> writes:

[...]

> If backporting would unfortunately be impossible, does anybody know of a way to
> force the settings I want by using a script?

I have all my Compiz settings dumped to a text file which I load at
login ..

Created with command:
$ dconf dump /org/compiz/ > ~/.compiz-settings.dconf

Loaded at login with command:
$ sleep 3; dconf load /org/compiz/ < ~/.compiz-settings.dconf

You can make the command run at login by putting the following into an
autostart file [~/.config/autostart/load-compiz-settings.desktop]:

[Desktop Entry]
Type=Application
Exec=sh -c 'sleep 3; dconf load /org/compiz/ < ~/.compiz-settings.dconf'
Hidden=false
NoDisplay=false
X-GNOME-Autostart-enabled=true
Name=Load Compiz settings

The sleep is there for some reason I cannot remember, probably due to a
race at login where the loaded settings would not apply properly if done
too early.

Make sure things are set up correctly first and that the settings have
properly been set in dconf as well, before dumping. Additionally, I also
lost keybindings defined in Gnome keyboard properties (control panel).
To set those at startup I run the following commands in addition:

dconf write /org/gnome/desktop/wm/keybindings/switch-to-workspace-1 "['<Super>j']"
dconf write /org/gnome/desktop/wm/keybindings/switch-to-workspace-2 "['<Super>k']"
dconf write /org/gnome/desktop/wm/keybindings/switch-to-workspace-3 "['<Super>l']"
dconf write /org/gnome/desktop/wm/keybindings/switch-to-workspace-4 "['<Super>oslash']"

By that time, you'll probably want to put all the mess together in a
script and load that at startup through .desktop autostart mechanism
above, instead.

This bug is a real pain for those of us who like to customize
keybindings and Compiz settings in general.

Although two people reported problems, what I said at comment 24 is still
working fine here. But I wouldn't try to do this if I didn't know how to
recover from a bad configuration.

André,
Thank you for your warning. I had also tried your fix, but Unity got completely screwed up - same as described by the two other people that reported this issue. I tried to play a little bit at recovering the situation - but to no avail. Even trying to reinstall the packages involved through the single/recovery boot did not work. Fortunately, I had made a clone backup image of my SSD just before attempting the fix...

Stegard,
I have tried your autostart solution, but it didn't work for me...I will have to investigate a little more to see if perhaps I have also a problem with Gnome keyboard properties. Also: do I have to register the file as an app in some way?

Changed in compiz:
milestone: 0.9.9.2 → 0.9.10.0
Stephen M. Webb (bregma) on 2013-07-23
Changed in compiz:
status: Fix Committed → Fix Released
Changed in compiz (Ubuntu):
assignee: Sam Spilsbury (smspillaz) → nobody
Changed in compiz:
assignee: Sam Spilsbury (smspillaz) → nobody
33 comments hidden view all 113 comments

Is there a way to log what application sets gsettings and when? That could help find the culprit.

Also, why is there anything that sets these shortcuts *at all*? That should be a user setting and not something an application does on its own.

Fred (eldmannen+launchpad) wrote :

Carl-Eric Menzel,
Gsettings is a front-end for dconf.
You can watch when something gets written to dconf;
$ dconf watch /
or more specific
$ dconf watch /org/gnome/desktop/wm/keybindings

Thank you Carl-Eric for your idea of monitoring what apps set gsettings and what do they do exactly.
And also to Fred for indicating how to actually do this monitoring.
Now my question is: how could we execute a shell with the "dconf watch" command early enough in the boot process so as to have monitoring as soon as possible and where should we place it? Inside the init folder or somewhere else? In other words, how could we trigger early monitoring that would catch the culprit or the possible race condition?
Another question I have: is /org/gnome/desktop/wm/keybindings the only key that ultimately indicates the keybinding settings?

Mark Abraham (mark-j-abraham) wrote :

I also observe this behaviour in 13.10.

Halil Özgür (halil-ozgur) wrote :

I'm experiencing this daily both in my work machine and home machine. Both are 13.10.

Timo Aaltonen (tjaalton) wrote :

how come this bug is marked fix released when I'm still seeing it on trusty..?

Martin Pitt (pitti) wrote :

I agree, I still see it as well, just a bit less often.

Changed in compiz (Ubuntu):
status: Fix Released → Confirmed
Changed in compiz:
status: Fix Released → Confirmed

Good to see that it's still being looked at.

I'm trying the "dconf watch /" thing now, but I see two problems with it: The output of dconf is not timestamped nor does it show what process caused the dconf change. Is there any way to obtain that information?

Stego (stegomon) wrote :

Can confirm this bug on Trusty 14.04. Some keyboard shortcuts reset every other reboot. ccsm installed

Øyvind Stegard (oyvinst) wrote :

Custom window management shortcuts set via the standard keyboard prefs in Ubuntu Trusty 14.04 confirmed lost after logout/login. Clean installation and no CCSM installed.

This still occurs randomly in 14.04. Seems to be happening no less (and no more) often than in 13.10.

I'd still like to know whether there's a way to see which process is actually changing the settings.

I confirm that this bug is still affecting Compiz in 14.04LTS. Clean install + no CCSM.
So, yet another new release (supposedly a "stable, conservative and long-term" one) and still this has not been fixed !
It has now been a year and a half - across 4 releases - and still there is no one assigned for fixing or looking into this...
Still there is some progress, as now the bug importance is registered as high. High for high time to fix it, no ?
Which team is supposed to debug this? Compiz or another one? There seems to be some other startup processes possibly involved and causing a race condition resulting in the mishap...but which ones and has this been reported to the respective maintenance teams for them to investigate?

brianbridge (brianjbridge) wrote :

Confirming this bug exists on 14.04 (with ccsm installed). I set custom shortcuts for navigating workspaces, and they are back to defualts after reboot.

v. (tishma) wrote :

14.04 :(

I can confirm the workaround using flat file configuration still works at 14.04. Steps to apply:

1. Install compizconfig-settings-manager
2. Open ccsm and go to Preferences > Export and save your preferences "saved.profile"
3. Change Backend to "Flat-file Configuration Backend" (here some people get stucked with a messed desktop with will be fixed at step "4")
4. Import your saved profiled (step "2")

Hey Folks,

Apologies for this bug and having let it sit for so long. It's unfortunate that Sam left working on Compiz before having this bug resolved. Based on his merge proposals linked to this bug, he seemed to have an idea what was going on here, but he also said the fix is complicated.

I'm going to attempt to figure out what is going on here, but it may be slow going. I'm going to make it a high priority to work on it and also keep in mind that if I do find a fix, that I can try to SRU it for 14.04.

Thank you for your patience!

Changed in compiz:
milestone: 0.9.10.0 → 0.9.11.0
assignee: nobody → Christopher Townsend (townsend)
no longer affects: compiz/0.9.9
Changed in compiz:
status: Confirmed → In Progress
Krister (thekswenson) wrote :
Download full text (5.7 KiB)

Thank you Christopher...
  godspeed!

On 20 May 2014 15:58, Christopher Townsend <
<email address hidden>> wrote:

> Hey Folks,
>
> Apologies for this bug and having let it sit for so long. It's
> unfortunate that Sam left working on Compiz before having this bug
> resolved. Based on his merge proposals linked to this bug, he seemed to
> have an idea what was going on here, but he also said the fix is
> complicated.
>
> I'm going to attempt to figure out what is going on here, but it may be
> slow going. I'm going to make it a high priority to work on it and also
> keep in mind that if I do find a fix, that I can try to SRU it for
> 14.04.
>
> Thank you for your patience!
>
> ** Changed in: compiz
> Milestone: 0.9.10.0 => 0.9.11.0
>
> ** Changed in: compiz
> Assignee: (unassigned) => Christopher Townsend (townsend)
>
> ** No longer affects: compiz/0.9.9
>
> ** Changed in: compiz
> Status: Confirmed => In Progress
>
> --
> You received this bug notification because you are subscribed to a
> duplicate bug report (1087738).
> https://bugs.launchpad.net/bugs/1063617
>
> Title:
> 1:0.9.8+bzr3319-0ubuntu1 regression: keeps setting gsettings keys to
> wrong values
>
> Status in Compiz:
> In Progress
> Status in “compiz” package in Ubuntu:
> Confirmed
>
> Bug description:
> NOTE: This bug is for Ubuntu 12.10 and later only. If you experience
> something similar in 12.04 then please see bug 964270.
>
> ORIGINAL DESCRIPTION:
> Since version 1:0.9.8+bzr3319-0ubuntu1, compiz/unity keeps messing up my
> gsettings (keybindings and WM prefs). This was already covered in bug
> 1042041, but the change there mostly caused the bug to happen consistently
> now.
>
> At every session startup I have a script to fix my settings like this:
>
> --------------- 8< ----------------
> gsettings reset org.gnome.desktop.wm.preferences auto-raise
> gsettings set org.gnome.desktop.wm.keybindings lower "['<Alt>b']"
> gsettings set org.gnome.desktop.wm.keybindings maximize "['<Super>Up']"
> gsettings set org.gnome.desktop.wm.keybindings unmaximize
> "['<Super>Down']"
> gsettings set org.gnome.desktop.wm.preferences focus-mode sloppy
> --------------- 8< ----------------
>
> But after restarting compiz, it changes the settings to:
>
> --------------- 8< ----------------
> $ gsettings get org.gnome.desktop.wm.preferences auto-raise
> true
> $ gsettings get org.gnome.desktop.wm.keybindings lower
> ['disabled']
> $ gsettings get org.gnome.desktop.wm.keybindings maximize
> ['<Control><Primary><Super>Up']
> $ gsettings get org.gnome.desktop.wm.keybindings unmaximize
> ['<Control><Primary><Super>Down']
> $ gsettings get org.gnome.desktop.wm.preferences focus-mode
> 'click'
> --------------- 8< ----------------
>
> I tried to move away /usr/bin/session-migration, that does not change
> anything, so it's not that script.
>
> ProblemType: Bug
> DistroRelease: Ubuntu 12.10
> Package: compiz 1:0.9.8.4-0ubuntu1
> ProcVersionSignature: Ubuntu 3.5.0-17.27-generic 3.5.5
> Uname: Linux 3.5.0-17-generic x86_64
> .tmp.unity.support.test.0:
>
> ApportVersion: 2.6.1-0ubuntu1
> Architecture...

Read more...

Ryan Tandy (rtandy) wrote :

On Tue, May 20, 2014 at 6:58 AM, Christopher Townsend
<email address hidden> wrote:
> I'm going to attempt to figure out what is going on here, but it may be
> slow going. I'm going to make it a high priority to work on it and also
> keep in mind that if I do find a fix, that I can try to SRU it for
> 14.04.

Someone named "luv" mentioned this bug in IRC a day or two ago, said
they were working on it and would post a patch soon. Might be worth
trying to join forces.

Lukas Vacek (lukas-vacek) wrote :

Hey.

Yes. I have been looking into this bug over last few days.

Attaching a patch which works for me.

You can run following commands to try:
apt-src install compiz
(cd to compiz dir create0
(set your ~/.quiltrc as usual)
quilt push -a
quilt import /path/to/settings_reset_fix
dpkg-buildpackage

Hi Lukas,

Thank you so very much for your contribution! I'll begin testing this out.

For anyone interested in testing this, I'm making a test PPA. It can be found at https://launchpad.net/~townsend/+archive/compiz-settings-reset-fix. As of this writing, I just uploaded the source package and the build has yet to begin. But once it builds and is published, you can add it and try it out.

Martin Pitt (pitti) wrote :

I enabled the PPA, upgraded, disabled the "gsettings" calls in my session script (workaround for this bug) and restarted my session five times. So far all of my keyboard and the auto-raise settings are still working. Many thanks Lukas!

I'll report here if I see this happen again with this PPA version.

Lukas Vacek (lukas-vacek) wrote :

Thanks.

I tried on my other up to date Trusty box last night and I can't reproduce the issue anymore (with the patch in), so a bit more info:

The issues found:

1) updateSetting (in gsettings/src/gsettings.c) always uses readOption (even when integration is turned on). This function should use readIntegratedOption when integration is turned on (as readSetting does).

2) ccsGSettingsIntegratedSettingWriteValue (in ccs_gnome_integration_gsettings_integrated_setting.c) function is called when writing a new value to gsettings backend. In this function, newVariant is set only when the old a new values differ but at the end of the function, the key is reset when newVariant is NULL.

Testing:

The two packages you want to update are (at least) libcompizconfig0 and compiz-gnome.

If you want to test the patch, please make sure to restart compiz (and ccsm if currently running) after installing the new packages. Maybe better just to reboot the box after install when testing (just to be sure the new libraries are used). If your settings are reset at this stage, set the settings as you like and start testing now :-).

Also note that if you are using the "Flat file workaround" or Gsettings backend with "desktop integration" disabled this patch should not affect you. So to verify the patch actually fixes the issue, you should export your settings, switch to gsettings backend and turn on desktop integration and import your settings.

Changed in compiz (Ubuntu):
status: Confirmed → In Progress
assignee: nobody → Christopher Townsend (townsend)
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package compiz - 1:0.9.11+14.10.20140606-0ubuntu1

---------------
compiz (1:0.9.11+14.10.20140606-0ubuntu1) utopic; urgency=low

  [ Chris Townsend ]
  * Only ungrab the Mod2Mask modifier on buttons 4-7 to allow scrolling
    in unfocused Gtk windows while still allowing keybinding modifiers
    to other scroll wheel actions. (LP: #1311788)
  * Fix issue where window decorations would be placed under the Panel
    when opening a new window from an already open window. This is due
    to the already open window being taller or just as tall without be
    maximized than the workspace. (LP: #1303462)
  * Only constrain the non-modifier scrolling to the vertical scrolling
    buttons - buttons 4 & 5. (LP: #1311303)
  * Fix issue where maximized windows would get moved to different
    workspaces when disconnecting/connecting an external monitor.
    Windows should stay in the same workspace they are in when the
    monitor event occurs. (LP: #1304531)
  * Fix issue where custom keyboard shortcuts would get reset to
    defaults when rebooting or restarting Compiz. (LP: #1063617)
  * Fixes issue in the Expo plugin where a gap is shown in the place
    where the Launcher and Panel should be when windows are maximized.
    This was originally removed in rev. 3481. (LP: #1087090)
  * Fix issue where horizontal and vertical keyboard resizing could not
    happen at the same time. (LP: #347390)

  [ Marco Trevisan (Treviño) ]
  * Scale: use XShape extension to exclude dnd input in the screen-parts
    outside workArea This will work property also in multi-monitor,
    without requiring multiple X windows for each output device. Also
    don't terminate the scale unless a drag-n-drop action is not really
    over. Add a spinner that shows up over a window, during the DnD
    timeout. Plus, make sure we terminate the scale without focusing the
    selected icon when cancelling it and some code cleanup (LP: #607796)
  * Event: set the screen grabbed also when we get a NotifyWhileGrabbed
    Focus{In,Out} event (LP: #1305586)
 -- Ubuntu daily release <email address hidden> Fri, 06 Jun 2014 09:43:06 +0000

Changed in compiz (Ubuntu):
status: In Progress → Fix Released
Paul Backus (lifeenemy) wrote :

Will the fix be rolled out in automatic updates, or do we need to do something manually to apply it?

Apologies, I'm not nearly tech saavy enough for this site.

Paul, the fix has been released only for Utopic for now, so if you're using the development version of Ubuntu you'll get it automatically, otherwise if you're running 14.04, the fix will be released soon as an SRU update (you'll get instructions here).

Does this mean an upstream fix which would make it into Debian too? If so what's the timescale?

Alternatively any way of getting a Wheezy-compatible backport sooner?

If so, I'd switch our 15 @ShrimpingIt studio laptops to LXDE if Compiz Scale was stable once again (this bug reverted plugin settings making use of plugins unreliable).

Changed in compiz:
status: In Progress → Fix Committed
milestone: 0.9.11.0 → 0.9.12.0
Lukas Vacek (lukas-vacek) wrote :
Download full text (5.0 KiB)

Just curious ... any ETA for this fix hitting 14.04?

On Wed, Jun 11, 2014 at 5:45 PM, Launchpad Bug Tracker
<email address hidden> wrote:
> ** Branch linked: lp:~townsend/compiz/0.9.11.1
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/1063617
>
> Title:
> 1:0.9.8+bzr3319-0ubuntu1 regression: keeps setting gsettings keys to
> wrong values
>
> Status in Compiz:
> Fix Committed
> Status in Compiz 0.9.11 series:
> In Progress
> Status in “compiz” package in Ubuntu:
> Fix Released
>
> Bug description:
> NOTE: This bug is for Ubuntu 12.10 and later only. If you experience
> something similar in 12.04 then please see bug 964270.
>
> ORIGINAL DESCRIPTION:
> Since version 1:0.9.8+bzr3319-0ubuntu1, compiz/unity keeps messing up my gsettings (keybindings and WM prefs). This was already covered in bug 1042041, but the change there mostly caused the bug to happen consistently now.
>
> At every session startup I have a script to fix my settings like this:
>
> --------------- 8< ----------------
> gsettings reset org.gnome.desktop.wm.preferences auto-raise
> gsettings set org.gnome.desktop.wm.keybindings lower "['<Alt>b']"
> gsettings set org.gnome.desktop.wm.keybindings maximize "['<Super>Up']"
> gsettings set org.gnome.desktop.wm.keybindings unmaximize "['<Super>Down']"
> gsettings set org.gnome.desktop.wm.preferences focus-mode sloppy
> --------------- 8< ----------------
>
> But after restarting compiz, it changes the settings to:
>
> --------------- 8< ----------------
> $ gsettings get org.gnome.desktop.wm.preferences auto-raise
> true
> $ gsettings get org.gnome.desktop.wm.keybindings lower
> ['disabled']
> $ gsettings get org.gnome.desktop.wm.keybindings maximize
> ['<Control><Primary><Super>Up']
> $ gsettings get org.gnome.desktop.wm.keybindings unmaximize
> ['<Control><Primary><Super>Down']
> $ gsettings get org.gnome.desktop.wm.preferences focus-mode
> 'click'
> --------------- 8< ----------------
>
> I tried to move away /usr/bin/session-migration, that does not change
> anything, so it's not that script.
>
> ProblemType: Bug
> DistroRelease: Ubuntu 12.10
> Package: compiz 1:0.9.8.4-0ubuntu1
> ProcVersionSignature: Ubuntu 3.5.0-17.27-generic 3.5.5
> Uname: Linux 3.5.0-17-generic x86_64
> .tmp.unity.support.test.0:
>
> ApportVersion: 2.6.1-0ubuntu1
> Architecture: amd64
> CompizPlugins: [core,composite,opengl,compiztoolbox,decor,vpswitch,snap,mousepoll,resize,place,move,wall,grid,regex,imgpng,session,gnomecompat,animation,fade,unitymtgrabhandles,workarounds,scale,expo,ezoom,unityshell]
> CompositorRunning: compiz
> Date: Mon Oct 8 10:23:04 2012
> DistUpgraded: Fresh install
> DistroCodename: quantal
> DistroVariant: ubuntu
> EcryptfsInUse: Yes
> GraphicsCard:
> Intel Corporation Core Processor Integrated Graphics Controller [8086:0046] (rev 02) (prog-if 00 [VGA controller])
> Subsystem: Lenovo Device [17aa:215a]
> InstallationMedia: Ubuntu 12.10 "Quantal Quetzal" - Alpha amd64 (20120627)
> MachineType: LENOVO 3323REG
> PackageArchitecture: all
> Plymou...

Read more...

Hi Lukas,

We are preparing the 14.04 Compiz SRU that includes this fix now. I'm guessing it will be in -proposed early next week.

description: updated
description: updated

Hello Martin, or anyone else affected,

Accepted compiz into trusty-proposed. The package will build now and be available at http://launchpad.net/ubuntu/+source/compiz/1:0.9.11.1+14.04.20140617-0ubuntu1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in compiz (Ubuntu Trusty):
status: New → Fix Committed
tags: added: verification-needed
Download full text (5.7 KiB)

Great. Thanks Chris!

On Thu, Jun 19, 2014 at 4:59 PM, Launchpad Bug Tracker
<email address hidden> wrote:
> ** Branch linked: lp:ubuntu/trusty-proposed/compiz
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/1063617
>
> Title:
> 1:0.9.8+bzr3319-0ubuntu1 regression: keeps setting gsettings keys to
> wrong values
>
> Status in Compiz:
> Fix Committed
> Status in Compiz 0.9.11 series:
> In Progress
> Status in “compiz” package in Ubuntu:
> Fix Released
> Status in “compiz” source package in Trusty:
> Fix Committed
>
> Bug description:
> [Impact]
>
> Many users set custom shortcuts in Compiz for various functionality.
> When this issue hits, many, if not all, of these custom shortcuts get
> reset to the defaults which can cause much frustration in the user.
> It is a very bad user experience.
>
> [Test case]
>
> 1. Open CCSM
> 2. Set a custom shortcut or change a behavior. For example, go to General Options->Focus & Raise Behavior and uncheck Click To Focus.
> 3. Restart the Unity session multiple times.
>
> [Regression potential]
>
> None identified.
>
> * Debdiff is found at
> https://bugs.launchpad.net/compiz/+bug/1303462/+attachment/4134214/+files
> /compiz-trusty-sru.debdiff *
>
> Original Description:
>
> NOTE: This bug is for Ubuntu 12.10 and later only. If you experience
> something similar in 12.04 then please see bug 964270.
>
> ORIGINAL DESCRIPTION:
> Since version 1:0.9.8+bzr3319-0ubuntu1, compiz/unity keeps messing up my gsettings (keybindings and WM prefs). This was already covered in bug 1042041, but the change there mostly caused the bug to happen consistently now.
>
> At every session startup I have a script to fix my settings like this:
>
> --------------- 8< ----------------
> gsettings reset org.gnome.desktop.wm.preferences auto-raise
> gsettings set org.gnome.desktop.wm.keybindings lower "['<Alt>b']"
> gsettings set org.gnome.desktop.wm.keybindings maximize "['<Super>Up']"
> gsettings set org.gnome.desktop.wm.keybindings unmaximize "['<Super>Down']"
> gsettings set org.gnome.desktop.wm.preferences focus-mode sloppy
> --------------- 8< ----------------
>
> But after restarting compiz, it changes the settings to:
>
> --------------- 8< ----------------
> $ gsettings get org.gnome.desktop.wm.preferences auto-raise
> true
> $ gsettings get org.gnome.desktop.wm.keybindings lower
> ['disabled']
> $ gsettings get org.gnome.desktop.wm.keybindings maximize
> ['<Control><Primary><Super>Up']
> $ gsettings get org.gnome.desktop.wm.keybindings unmaximize
> ['<Control><Primary><Super>Down']
> $ gsettings get org.gnome.desktop.wm.preferences focus-mode
> 'click'
> --------------- 8< ----------------
>
> I tried to move away /usr/bin/session-migration, that does not change
> anything, so it's not that script.
>
> ProblemType: Bug
> DistroRelease: Ubuntu 12.10
> Package: compiz 1:0.9.8.4-0ubuntu1
> ProcVersionSignature: Ubuntu 3.5.0-17.27-generic 3.5.5
> Uname: Linux 3.5.0-17-generic x86_64
> .tmp.unity.support.test.0:
>
> ApportVersion: 2.6.1-0ubunt...

Read more...

I checked the Test Case from bug description.

tags: added: verification-done
removed: verification-needed
Krister (thekswenson) wrote :

This works for me on a fully updated system.

description: updated

Hello Martin, or anyone else affected,

Accepted compiz into trusty-proposed. The package will build now and be available at http://launchpad.net/ubuntu/+source/compiz/1:0.9.11.1+14.04.20140623-0ubuntu1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

tags: removed: verification-done
tags: added: verification-needed
Andrés Manglano (manglasape) wrote :

This doesn't seem to fix the bug for me. :(

I tested changing the Refresh rate in "Composite" plugin from 50 to 60, but when I restart Unity the refresh rate return to 50, maybe I'm missing something.

tags: added: verification-failed
removed: verification-needed
information type: Public → Public Security
information type: Public Security → Public

@Manglasape,

I take it you have an Nvidia graphics card. There seems to be a separate bug where Nvidia graphics somehow defaults to 50Hz after reboots. I've tried fixing that bug, but it seems it's still not fixed. I don't have Nvidia, so it's hard for me to actually dig deep and try to fix it.

That said, I'm setting this back to verification-needed since your bug seems different. If you don't have Nvidia, then, well, something else is going on.

Thanks!

tags: added: verification-needed
removed: verification-failed
Andrés Manglano (manglasape) wrote :

@townsend

Oops, yes, I have an Nvidia graphics card, so I tested it again unchecking the "Clic to focus" option in "Focus & Raise Behavior" in General options and after restarting Unity the Clic to focus remains unchecked so it seems to work properly.

Sorry for my bad choice! :)

Ok, cool, thanks for confirming. Based on your response, I'm going to set this verification-done.

Thanks again!

tags: added: verification-done
removed: verification-needed

I also confirm that it works and I also tested with disabling click to focus. Several reboots later and this setting remains unset and focus follows mouse is in use.

Hello Martin, or anyone else affected,

Accepted compiz into trusty-proposed. The package will build now and be available at http://launchpad.net/ubuntu/+source/compiz/1:0.9.11.1+14.04.20140623-0ubuntu1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

tags: added: verification-needed
removed: verification-done
tags: added: verification-done
removed: verification-needed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package compiz - 1:0.9.11.1+14.04.20140701-0ubuntu1

---------------
compiz (1:0.9.11.1+14.04.20140701-0ubuntu1) trusty; urgency=medium

  [ Chris Townsend ]
  * Bump version to 0.9.11.1.

  [ Ubuntu daily release ]
  * New rebuild forced
 -- Ubuntu daily release <email address hidden> Tue, 01 Jul 2014 11:51:26 +0000

Changed in compiz (Ubuntu Trusty):
status: Fix Committed → Fix Released
Stephen M. Webb (bregma) on 2014-11-06
Changed in compiz:
status: Fix Committed → Fix Released
Displaying first 40 and last 40 comments. View all 113 comments or add a comment.